/* Account.c generated by valac 0.48.19, the Vala compiler
 * generated from Account.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <camel/camel.h>
#include <glib.h>

#define MAIL_BACKEND_TYPE_ACCOUNT (mail_backend_account_get_type ())
#define MAIL_BACKEND_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_BACKEND_TYPE_ACCOUNT, MailBackendAccount))
#define MAIL_BACKEND_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_BACKEND_TYPE_ACCOUNT, MailBackendAccountClass))
#define MAIL_BACKEND_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_BACKEND_TYPE_ACCOUNT))
#define MAIL_BACKEND_IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_BACKEND_TYPE_ACCOUNT))
#define MAIL_BACKEND_ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_BACKEND_TYPE_ACCOUNT, MailBackendAccountClass))

typedef struct _MailBackendAccount MailBackendAccount;
typedef struct _MailBackendAccountClass MailBackendAccountClass;
typedef struct _MailBackendAccountPrivate MailBackendAccountPrivate;
enum  {
	MAIL_BACKEND_ACCOUNT_0_PROPERTY,
	MAIL_BACKEND_ACCOUNT_SERVICE_PROPERTY,
	MAIL_BACKEND_ACCOUNT_NUM_PROPERTIES
};
static GParamSpec* mail_backend_account_properties[MAIL_BACKEND_ACCOUNT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MailBackendAccount {
	GObject parent_instance;
	MailBackendAccountPrivate * priv;
};

struct _MailBackendAccountClass {
	GObjectClass parent_class;
};

struct _MailBackendAccountPrivate {
	CamelService* _service;
};

static gint MailBackendAccount_private_offset;
static gpointer mail_backend_account_parent_class = NULL;

GType mail_backend_account_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailBackendAccount, g_object_unref)
MailBackendAccount* mail_backend_account_new (CamelService* service);
MailBackendAccount* mail_backend_account_construct (GType object_type,
                                                    CamelService* service);
guint mail_backend_account_hash (MailBackendAccount* account);
CamelService* mail_backend_account_get_service (MailBackendAccount* self);
gboolean mail_backend_account_equal (MailBackendAccount* self,
                                     MailBackendAccount* account2);
static void mail_backend_account_set_service (MailBackendAccount* self,
                                       CamelService* value);
static void mail_backend_account_finalize (GObject * obj);
static GType mail_backend_account_get_type_once (void);
static void _vala_mail_backend_account_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_mail_backend_account_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
mail_backend_account_get_instance_private (MailBackendAccount* self)
{
	return G_STRUCT_MEMBER_P (self, MailBackendAccount_private_offset);
}

MailBackendAccount*
mail_backend_account_construct (GType object_type,
                                CamelService* service)
{
	MailBackendAccount * self = NULL;
	g_return_val_if_fail (service != NULL, NULL);
	self = (MailBackendAccount*) g_object_new (object_type, "service", service, NULL);
	return self;
}

MailBackendAccount*
mail_backend_account_new (CamelService* service)
{
	return mail_backend_account_construct (MAIL_BACKEND_TYPE_ACCOUNT, service);
}

guint
mail_backend_account_hash (MailBackendAccount* account)
{
	GHashFunc _tmp0_;
	CamelService* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	guint result = 0U;
	g_return_val_if_fail (account != NULL, 0U);
	_tmp0_ = g_str_hash;
	_tmp1_ = account->priv->_service;
	_tmp2_ = camel_service_get_uid (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp0_ (_tmp3_);
	return result;
}

gboolean
mail_backend_account_equal (MailBackendAccount* self,
                            MailBackendAccount* account2)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (account2 != NULL, FALSE);
	result = mail_backend_account_hash (self) == mail_backend_account_hash (account2);
	return result;
}

CamelService*
mail_backend_account_get_service (MailBackendAccount* self)
{
	CamelService* result;
	CamelService* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_service;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
mail_backend_account_set_service (MailBackendAccount* self,
                                  CamelService* value)
{
	CamelService* old_value;
	g_return_if_fail (self != NULL);
	old_value = mail_backend_account_get_service (self);
	if (old_value != value) {
		CamelService* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_service);
		self->priv->_service = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, mail_backend_account_properties[MAIL_BACKEND_ACCOUNT_SERVICE_PROPERTY]);
	}
}

static void
mail_backend_account_class_init (MailBackendAccountClass * klass,
                                 gpointer klass_data)
{
	mail_backend_account_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MailBackendAccount_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_backend_account_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_backend_account_set_property;
	G_OBJECT_CLASS (klass)->finalize = mail_backend_account_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_BACKEND_ACCOUNT_SERVICE_PROPERTY, mail_backend_account_properties[MAIL_BACKEND_ACCOUNT_SERVICE_PROPERTY] = g_param_spec_object ("service", "service", "service", camel_service_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
mail_backend_account_instance_init (MailBackendAccount * self,
                                    gpointer klass)
{
	self->priv = mail_backend_account_get_instance_private (self);
}

static void
mail_backend_account_finalize (GObject * obj)
{
	MailBackendAccount * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_BACKEND_TYPE_ACCOUNT, MailBackendAccount);
	_g_object_unref0 (self->priv->_service);
	G_OBJECT_CLASS (mail_backend_account_parent_class)->finalize (obj);
}

static GType
mail_backend_account_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailBackendAccountClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_backend_account_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailBackendAccount), 0, (GInstanceInitFunc) mail_backend_account_instance_init, NULL };
	GType mail_backend_account_type_id;
	mail_backend_account_type_id = g_type_register_static (G_TYPE_OBJECT, "MailBackendAccount", &g_define_type_info, 0);
	MailBackendAccount_private_offset = g_type_add_instance_private (mail_backend_account_type_id, sizeof (MailBackendAccountPrivate));
	return mail_backend_account_type_id;
}

GType
mail_backend_account_get_type (void)
{
	static volatile gsize mail_backend_account_type_id__volatile = 0;
	if (g_once_init_enter (&mail_backend_account_type_id__volatile)) {
		GType mail_backend_account_type_id;
		mail_backend_account_type_id = mail_backend_account_get_type_once ();
		g_once_init_leave (&mail_backend_account_type_id__volatile, mail_backend_account_type_id);
	}
	return mail_backend_account_type_id__volatile;
}

static void
_vala_mail_backend_account_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MailBackendAccount * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_BACKEND_TYPE_ACCOUNT, MailBackendAccount);
	switch (property_id) {
		case MAIL_BACKEND_ACCOUNT_SERVICE_PROPERTY:
		g_value_set_object (value, mail_backend_account_get_service (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_mail_backend_account_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MailBackendAccount * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_BACKEND_TYPE_ACCOUNT, MailBackendAccount);
	switch (property_id) {
		case MAIL_BACKEND_ACCOUNT_SERVICE_PROPERTY:
		mail_backend_account_set_service (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

