/* HeaderBar.c generated by valac 0.48.19, the Vala compiler
 * generated from HeaderBar.vala, do not modify */

/*-
 * Copyright 2017-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <handy.h>
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

#define MAIL_TYPE_HEADER_BAR (mail_header_bar_get_type ())
#define MAIL_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_HEADER_BAR, MailHeaderBar))
#define MAIL_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_HEADER_BAR, MailHeaderBarClass))
#define MAIL_IS_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_HEADER_BAR))
#define MAIL_IS_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_HEADER_BAR))
#define MAIL_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_HEADER_BAR, MailHeaderBarClass))

typedef struct _MailHeaderBar MailHeaderBar;
typedef struct _MailHeaderBarClass MailHeaderBarClass;
typedef struct _MailHeaderBarPrivate MailHeaderBarPrivate;
enum  {
	MAIL_HEADER_BAR_0_PROPERTY,
	MAIL_HEADER_BAR_CAN_MARK_PROPERTY,
	MAIL_HEADER_BAR_CAN_SEARCH_PROPERTY,
	MAIL_HEADER_BAR_SEARCH_ENTRY_PROPERTY,
	MAIL_HEADER_BAR_NUM_PROPERTIES
};
static GParamSpec* mail_header_bar_properties[MAIL_HEADER_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MailHeaderBar {
	HdyHeaderBar parent_instance;
	MailHeaderBarPrivate * priv;
};

struct _MailHeaderBarClass {
	HdyHeaderBarClass parent_class;
};

struct _MailHeaderBarPrivate {
	gboolean _can_mark;
	gboolean _can_search;
	GtkSearchEntry* _search_entry;
	GtkGrid* spacing_widget;
};

struct _Block8Data {
	int _ref_count_;
	MailHeaderBar* self;
	gint spacing_position;
	gint offset;
};

static gint MailHeaderBar_private_offset;
static gpointer mail_header_bar_parent_class = NULL;

GType mail_header_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailHeaderBar, g_object_unref)
MailHeaderBar* mail_header_bar_new (void);
MailHeaderBar* mail_header_bar_construct (GType object_type);
void mail_header_bar_set_paned_positions (MailHeaderBar* self,
                                          gint start_position,
                                          gint end_position,
                                          gboolean start_changed);
GtkSearchEntry* mail_header_bar_get_search_entry (MailHeaderBar* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda13_ (Block8Data* _data8_,
                   GtkWidget* widget);
static void ____lambda13__gtk_callback (GtkWidget* widget,
                                 gpointer self);
gboolean mail_header_bar_get_can_mark (MailHeaderBar* self);
void mail_header_bar_set_can_mark (MailHeaderBar* self,
                                   gboolean value);
gboolean mail_header_bar_get_can_search (MailHeaderBar* self);
void mail_header_bar_set_can_search (MailHeaderBar* self,
                                     gboolean value);
static void mail_header_bar_set_search_entry (MailHeaderBar* self,
                                       GtkSearchEntry* value);
static GObject * mail_header_bar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
#define MAIL_MAIN_WINDOW_ACTION_GROUP_PREFIX "win"
#define MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_GROUP_PREFIX "."
#define MAIL_MAIN_WINDOW_ACTION_COMPOSE_MESSAGE "compose_message"
#define MAIL_MAIN_WINDOW_ACTION_REPLY "reply"
#define MAIL_MAIN_WINDOW_ACTION_REPLY_ALL "reply-all"
#define MAIL_MAIN_WINDOW_ACTION_FORWARD "forward"
#define MAIL_MAIN_WINDOW_ACTION_MARK_UNREAD "mark-unread"
#define MAIL_MAIN_WINDOW_ACTION_MARK_READ "mark-read"
#define MAIL_MAIN_WINDOW_ACTION_MARK_STAR "mark-star"
#define MAIL_MAIN_WINDOW_ACTION_MARK_UNSTAR "mark-unstar"
#define MAIL_MAIN_WINDOW_ACTION_ARCHIVE "archive"
#define MAIL_MAIN_WINDOW_ACTION_MOVE_TO_TRASH "trash"
static void _mail_header_bar___lambda14_ (MailHeaderBar* self);
static void __mail_header_bar___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void mail_header_bar_finalize (GObject * obj);
static GType mail_header_bar_get_type_once (void);
static void _vala_mail_header_bar_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_mail_header_bar_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
mail_header_bar_get_instance_private (MailHeaderBar* self)
{
	return G_STRUCT_MEMBER_P (self, MailHeaderBar_private_offset);
}

MailHeaderBar*
mail_header_bar_construct (GType object_type)
{
	MailHeaderBar * self = NULL;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	self = (MailHeaderBar*) g_object_new (object_type, "show-close-button", TRUE, "custom-title", _tmp1_, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

MailHeaderBar*
mail_header_bar_new (void)
{
	return mail_header_bar_construct (MAIL_TYPE_HEADER_BAR);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		MailHeaderBar* self;
		self = _data8_->self;
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
___lambda13_ (Block8Data* _data8_,
              GtkWidget* widget)
{
	MailHeaderBar* self;
	gboolean _tmp0_ = FALSE;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gint widget_position = 0;
	gint _tmp4_ = 0;
	self = _data8_->self;
	g_return_if_fail (widget != NULL);
	_tmp1_ = hdy_header_bar_get_custom_title ((HdyHeaderBar*) self);
	_tmp2_ = _tmp1_;
	if (widget == _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		GtkStyleContext* _tmp3_;
		_tmp3_ = gtk_widget_get_style_context (widget);
		_tmp0_ = gtk_style_context_has_class (_tmp3_, "right");
	}
	if (_tmp0_) {
		return;
	}
	gtk_container_child_get ((GtkContainer*) self, widget, "position", &_tmp4_, NULL, NULL);
	widget_position = _tmp4_;
	if (widget_position < _data8_->spacing_position) {
		gint _tmp5_;
		gint _tmp6_;
		g_object_get ((HdyHeaderBar*) self, "spacing", &_tmp5_, NULL);
		_tmp6_ = _tmp5_;
		_data8_->offset += gtk_widget_get_allocated_width (widget) + _tmp6_;
	}
}

static void
____lambda13__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
	___lambda13_ (self, widget);
}

void
mail_header_bar_set_paned_positions (MailHeaderBar* self,
                                     gint start_position,
                                     gint end_position,
                                     gboolean start_changed)
{
	GtkSearchEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_search_entry;
	g_object_set ((GtkWidget*) _tmp0_, "width-request", (end_position - start_position) + 3, NULL);
	if (start_changed) {
		Block8Data* _data8_;
		GtkGrid* _tmp1_;
		gint _tmp2_ = 0;
		GtkStyleContext* style_context = NULL;
		GtkStyleContext* _tmp3_;
		GtkStyleContext* _tmp4_;
		GtkStyleContext* _tmp5_;
		GtkStyleContext* _tmp6_;
		GtkBorder _tmp7_ = {0};
		gint _tmp8_;
		gint _tmp9_;
		GtkGrid* _tmp10_;
		_data8_ = g_slice_new0 (Block8Data);
		_data8_->_ref_count_ = 1;
		_data8_->self = g_object_ref (self);
		_tmp1_ = self->priv->spacing_widget;
		gtk_container_child_get ((GtkContainer*) self, (GtkWidget*) _tmp1_, "position", &_tmp2_, NULL, NULL);
		_data8_->spacing_position = _tmp2_;
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		style_context = _tmp4_;
		_tmp5_ = style_context;
		_tmp6_ = style_context;
		gtk_style_context_get_padding (_tmp5_, gtk_style_context_get_state (_tmp6_), &_tmp7_);
		_data8_->offset = (gint) _tmp7_.left;
		gtk_container_forall ((GtkContainer*) self, ____lambda13__gtk_callback, _data8_);
		g_object_get ((HdyHeaderBar*) self, "spacing", &_tmp8_, NULL);
		_tmp9_ = _tmp8_;
		_data8_->offset += _tmp9_;
		_tmp10_ = self->priv->spacing_widget;
		g_object_set ((GtkWidget*) _tmp10_, "width-request", (start_position - MIN (_data8_->offset, start_position)) - 1, NULL);
		_g_object_unref0 (style_context);
		block8_data_unref (_data8_);
		_data8_ = NULL;
	}
}

gboolean
mail_header_bar_get_can_mark (MailHeaderBar* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_mark;
	return result;
}

void
mail_header_bar_set_can_mark (MailHeaderBar* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = mail_header_bar_get_can_mark (self);
	if (old_value != value) {
		self->priv->_can_mark = value;
		g_object_notify_by_pspec ((GObject *) self, mail_header_bar_properties[MAIL_HEADER_BAR_CAN_MARK_PROPERTY]);
	}
}

gboolean
mail_header_bar_get_can_search (MailHeaderBar* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_search;
	return result;
}

void
mail_header_bar_set_can_search (MailHeaderBar* self,
                                gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = mail_header_bar_get_can_search (self);
	if (old_value != value) {
		self->priv->_can_search = value;
		g_object_notify_by_pspec ((GObject *) self, mail_header_bar_properties[MAIL_HEADER_BAR_CAN_SEARCH_PROPERTY]);
	}
}

GtkSearchEntry*
mail_header_bar_get_search_entry (MailHeaderBar* self)
{
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_search_entry;
	result = _tmp0_;
	return result;
}

static void
mail_header_bar_set_search_entry (MailHeaderBar* self,
                                  GtkSearchEntry* value)
{
	GtkSearchEntry* old_value;
	g_return_if_fail (self != NULL);
	old_value = mail_header_bar_get_search_entry (self);
	if (old_value != value) {
		GtkSearchEntry* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_search_entry);
		self->priv->_search_entry = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, mail_header_bar_properties[MAIL_HEADER_BAR_SEARCH_ENTRY_PROPERTY]);
	}
}

static void
_mail_header_bar___lambda14_ (MailHeaderBar* self)
{
	GError* _inner_error0_ = NULL;
	{
		g_app_info_launch_default_for_uri ("settings://accounts/online", NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("HeaderBar.vala:169: Failed to open account settings: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__mail_header_bar___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	_mail_header_bar___lambda14_ ((MailHeaderBar*) self);
}

static GObject *
mail_header_bar_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MailHeaderBar * self;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkButton* compose_button = NULL;
	gchar* _tmp2_;
	GtkButton* _tmp3_ = NULL;
	GtkButton* _tmp4_;
	GtkApplication* _tmp5_;
	GtkButton* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkGrid* _tmp14_;
	gchar* _tmp15_;
	GtkSearchEntry* _tmp16_ = NULL;
	GtkSearchEntry* _tmp17_;
	GraniteSwitchModelButton* load_images_menuitem = NULL;
	GraniteSwitchModelButton* _tmp18_;
	GtkModelButton* account_settings_menuitem = NULL;
	GtkModelButton* _tmp19_;
	GtkModelButton* _tmp20_;
	GtkSeparator* app_menu_separator = NULL;
	GtkSeparator* _tmp21_ = NULL;
	GtkGrid* app_menu_grid = NULL;
	GtkGrid* _tmp22_ = NULL;
	GtkGrid* _tmp23_;
	GraniteSwitchModelButton* _tmp24_;
	GtkGrid* _tmp25_;
	GtkSeparator* _tmp26_;
	GtkGrid* _tmp27_;
	GtkModelButton* _tmp28_;
	GtkGrid* _tmp29_;
	GtkPopover* app_menu_popover = NULL;
	GtkPopover* _tmp30_;
	GtkPopover* _tmp31_;
	GtkGrid* _tmp32_;
	GtkMenuButton* app_menu = NULL;
	GtkImage* _tmp33_;
	GtkPopover* _tmp34_;
	GtkPopover* _tmp35_;
	gchar* _tmp36_;
	GtkMenuButton* _tmp37_ = NULL;
	GtkButton* reply_button = NULL;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkApplication* _tmp41_;
	GtkButton* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gchar** _tmp45_;
	gchar** _tmp46_;
	gchar** _tmp47_;
	gint _tmp47__length1;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GtkButton* reply_all_button = NULL;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkButton* _tmp52_;
	GtkApplication* _tmp53_;
	GtkButton* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	gchar** _tmp57_;
	gchar** _tmp58_;
	gchar** _tmp59_;
	gint _tmp59__length1;
	gchar* _tmp60_;
	gchar* _tmp61_;
	GtkButton* forward_button = NULL;
	GtkButton* _tmp62_;
	GtkButton* _tmp63_;
	GtkButton* _tmp64_;
	GtkApplication* _tmp65_;
	GtkButton* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	gchar** _tmp69_;
	gchar** _tmp70_;
	gchar** _tmp71_;
	gint _tmp71__length1;
	gchar* _tmp72_;
	gchar* _tmp73_;
	GtkMenuItem* mark_unread_item = NULL;
	GtkMenuItem* _tmp74_;
	GtkMenuItem* _tmp75_;
	GtkMenuItem* _tmp76_;
	GtkMenuItem* _tmp77_;
	GtkMenuItem* _tmp78_;
	GtkMenuItem* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	GraniteAccelLabel* _tmp82_;
	GraniteAccelLabel* _tmp83_;
	GtkMenuItem* mark_read_item = NULL;
	GtkMenuItem* _tmp84_;
	GtkMenuItem* _tmp85_;
	GtkMenuItem* _tmp86_;
	GtkMenuItem* _tmp87_;
	GtkMenuItem* _tmp88_;
	GtkMenuItem* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	GraniteAccelLabel* _tmp92_;
	GraniteAccelLabel* _tmp93_;
	GtkMenuItem* mark_star_item = NULL;
	GtkMenuItem* _tmp94_;
	GtkMenuItem* _tmp95_;
	GtkMenuItem* _tmp96_;
	GtkMenuItem* _tmp97_;
	GtkMenuItem* _tmp98_;
	GtkMenuItem* _tmp99_;
	const gchar* _tmp100_;
	const gchar* _tmp101_;
	GraniteAccelLabel* _tmp102_;
	GraniteAccelLabel* _tmp103_;
	GtkMenuItem* mark_unstar_item = NULL;
	GtkMenuItem* _tmp104_;
	GtkMenuItem* _tmp105_;
	GtkMenuItem* _tmp106_;
	GtkMenuItem* _tmp107_;
	GtkMenuItem* _tmp108_;
	GtkMenuItem* _tmp109_;
	const gchar* _tmp110_;
	const gchar* _tmp111_;
	GraniteAccelLabel* _tmp112_;
	GraniteAccelLabel* _tmp113_;
	GtkMenu* mark_menu = NULL;
	GtkMenu* _tmp114_;
	GtkMenu* _tmp115_;
	GtkMenuItem* _tmp116_;
	GtkMenu* _tmp117_;
	GtkMenuItem* _tmp118_;
	GtkMenu* _tmp119_;
	GtkMenuItem* _tmp120_;
	GtkMenu* _tmp121_;
	GtkMenuItem* _tmp122_;
	GtkMenu* _tmp123_;
	GtkMenuButton* mark_button = NULL;
	GtkImage* _tmp124_;
	GtkMenu* _tmp125_;
	GtkMenu* _tmp126_;
	gchar* _tmp127_;
	GtkMenuButton* _tmp128_ = NULL;
	GtkButton* archive_button = NULL;
	GtkButton* _tmp129_;
	GtkButton* _tmp130_;
	GtkButton* _tmp131_;
	GtkApplication* _tmp132_;
	GtkButton* _tmp133_;
	const gchar* _tmp134_;
	const gchar* _tmp135_;
	gchar** _tmp136_;
	gchar** _tmp137_;
	gchar** _tmp138_;
	gint _tmp138__length1;
	gchar* _tmp139_;
	gchar* _tmp140_;
	GtkButton* trash_button = NULL;
	GtkButton* _tmp141_;
	GtkButton* _tmp142_;
	GtkButton* _tmp143_;
	GtkApplication* _tmp144_;
	GtkButton* _tmp145_;
	const gchar* _tmp146_;
	const gchar* _tmp147_;
	gchar** _tmp148_;
	gchar** _tmp149_;
	gchar** _tmp150_;
	gint _tmp150__length1;
	gchar* _tmp151_;
	gchar* _tmp152_;
	GtkButton* _tmp153_;
	GtkGrid* _tmp154_;
	GtkSearchEntry* _tmp155_;
	GtkButton* _tmp156_;
	GtkButton* _tmp157_;
	GtkButton* _tmp158_;
	GtkSeparator* _tmp159_;
	GtkSeparator* _tmp160_;
	GtkMenuButton* _tmp161_;
	GtkButton* _tmp162_;
	GtkButton* _tmp163_;
	GtkMenuButton* _tmp164_;
	GtkMenuButton* _tmp165_;
	GtkSearchEntry* _tmp166_;
	GSettings* settings = NULL;
	GSettings* _tmp167_;
	GSettings* _tmp168_;
	GraniteSwitchModelButton* _tmp169_;
	GtkModelButton* _tmp170_;
	parent_class = G_OBJECT_CLASS (mail_header_bar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_HEADER_BAR, MailHeaderBar);
	_tmp0_ = g_application_get_default ();
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
	application_instance = _tmp1_;
	_tmp2_ = g_strdup (MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_COMPOSE_MESSAGE);
	_tmp3_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-message-new", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	gtk_actionable_set_action_name ((GtkActionable*) _tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp3_);
	compose_button = _tmp3_;
	_tmp4_ = compose_button;
	_tmp5_ = application_instance;
	_tmp6_ = compose_button;
	_tmp7_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp10_ = _tmp9_ = gtk_application_get_accels_for_action (_tmp5_, _tmp8_);
	_tmp11_ = _tmp10_;
	_tmp11__length1 = _vala_array_length (_tmp9_);
	_tmp12_ = granite_markup_accel_tooltip (_tmp11_, (gint) _vala_array_length (_tmp9_), _ ("Compose new message"));
	_tmp13_ = _tmp12_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp4_, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
	_tmp14_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->spacing_widget);
	self->priv->spacing_widget = _tmp14_;
	_tmp15_ = g_strdup (_ ("Search Mail"));
	_tmp16_ = (GtkSearchEntry*) gtk_search_entry_new ();
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp16_, _tmp15_);
	_g_free0 (_tmp15_);
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	mail_header_bar_set_search_entry (self, _tmp17_);
	_g_object_unref0 (_tmp17_);
	_tmp18_ = granite_switch_model_button_new (_ ("Always Show Remote Images"));
	g_object_ref_sink (_tmp18_);
	load_images_menuitem = _tmp18_;
	_tmp19_ = (GtkModelButton*) gtk_model_button_new ();
	g_object_ref_sink (_tmp19_);
	account_settings_menuitem = _tmp19_;
	_tmp20_ = account_settings_menuitem;
	g_object_set (_tmp20_, "text", _ ("Account Settings…"), NULL);
	_tmp21_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp21_, 3);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp21_, 3);
	g_object_ref_sink (_tmp21_);
	app_menu_separator = _tmp21_;
	_tmp22_ = (GtkGrid*) gtk_grid_new ();
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp22_, 3);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp22_, 3);
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp22_, GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp22_);
	app_menu_grid = _tmp22_;
	_tmp23_ = app_menu_grid;
	_tmp24_ = load_images_menuitem;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = app_menu_grid;
	_tmp26_ = app_menu_separator;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
	_tmp27_ = app_menu_grid;
	_tmp28_ = account_settings_menuitem;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = app_menu_grid;
	gtk_widget_show_all ((GtkWidget*) _tmp29_);
	_tmp30_ = (GtkPopover*) gtk_popover_new (NULL);
	g_object_ref_sink (_tmp30_);
	app_menu_popover = _tmp30_;
	_tmp31_ = app_menu_popover;
	_tmp32_ = app_menu_grid;
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp33_);
	_tmp34_ = app_menu_popover;
	_tmp35_ = _g_object_ref0 (_tmp34_);
	_tmp36_ = g_strdup (_ ("Menu"));
	_tmp37_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp37_, (GtkWidget*) _tmp33_);
	_g_object_unref0 (_tmp33_);
	gtk_menu_button_set_popover (_tmp37_, _tmp35_);
	_g_object_unref0 (_tmp35_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp37_, _tmp36_);
	_g_free0 (_tmp36_);
	g_object_ref_sink (_tmp37_);
	app_menu = _tmp37_;
	_tmp38_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-reply-sender", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp38_);
	reply_button = _tmp38_;
	_tmp39_ = reply_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp39_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_REPLY);
	_tmp40_ = reply_button;
	_tmp41_ = application_instance;
	_tmp42_ = reply_button;
	_tmp43_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp42_);
	_tmp44_ = _tmp43_;
	_tmp46_ = _tmp45_ = gtk_application_get_accels_for_action (_tmp41_, _tmp44_);
	_tmp47_ = _tmp46_;
	_tmp47__length1 = _vala_array_length (_tmp45_);
	_tmp48_ = granite_markup_accel_tooltip (_tmp47_, (gint) _vala_array_length (_tmp45_), _ ("Reply"));
	_tmp49_ = _tmp48_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp40_, _tmp49_);
	_g_free0 (_tmp49_);
	_tmp47_ = (_vala_array_free (_tmp47_, _tmp47__length1, (GDestroyNotify) g_free), NULL);
	_tmp50_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-reply-all", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp50_);
	reply_all_button = _tmp50_;
	_tmp51_ = reply_all_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp51_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_REPLY_ALL);
	_tmp52_ = reply_all_button;
	_tmp53_ = application_instance;
	_tmp54_ = reply_all_button;
	_tmp55_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp54_);
	_tmp56_ = _tmp55_;
	_tmp58_ = _tmp57_ = gtk_application_get_accels_for_action (_tmp53_, _tmp56_);
	_tmp59_ = _tmp58_;
	_tmp59__length1 = _vala_array_length (_tmp57_);
	_tmp60_ = granite_markup_accel_tooltip (_tmp59_, (gint) _vala_array_length (_tmp57_), _ ("Reply All"));
	_tmp61_ = _tmp60_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp52_, _tmp61_);
	_g_free0 (_tmp61_);
	_tmp59_ = (_vala_array_free (_tmp59_, _tmp59__length1, (GDestroyNotify) g_free), NULL);
	_tmp62_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-forward", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp62_);
	forward_button = _tmp62_;
	_tmp63_ = forward_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp63_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_FORWARD);
	_tmp64_ = forward_button;
	_tmp65_ = application_instance;
	_tmp66_ = forward_button;
	_tmp67_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp66_);
	_tmp68_ = _tmp67_;
	_tmp70_ = _tmp69_ = gtk_application_get_accels_for_action (_tmp65_, _tmp68_);
	_tmp71_ = _tmp70_;
	_tmp71__length1 = _vala_array_length (_tmp69_);
	_tmp72_ = granite_markup_accel_tooltip (_tmp71_, (gint) _vala_array_length (_tmp69_), _ ("Forward"));
	_tmp73_ = _tmp72_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp64_, _tmp73_);
	_g_free0 (_tmp73_);
	_tmp71_ = (_vala_array_free (_tmp71_, _tmp71__length1, (GDestroyNotify) g_free), NULL);
	_tmp74_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp74_);
	mark_unread_item = _tmp74_;
	_tmp75_ = mark_unread_item;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp75_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_UNREAD);
	_tmp76_ = mark_unread_item;
	_tmp77_ = mark_unread_item;
	g_object_bind_property_with_closures ((GObject*) _tmp76_, "sensitive", (GObject*) _tmp77_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp78_ = mark_unread_item;
	_tmp79_ = mark_unread_item;
	_tmp80_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp79_);
	_tmp81_ = _tmp80_;
	_tmp82_ = granite_accel_label_new_from_action_name (_ ("Mark as Unread"), _tmp81_);
	g_object_ref_sink (_tmp82_);
	_tmp83_ = _tmp82_;
	gtk_container_add ((GtkContainer*) _tmp78_, (GtkWidget*) _tmp83_);
	_g_object_unref0 (_tmp83_);
	_tmp84_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp84_);
	mark_read_item = _tmp84_;
	_tmp85_ = mark_read_item;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp85_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_READ);
	_tmp86_ = mark_read_item;
	_tmp87_ = mark_read_item;
	g_object_bind_property_with_closures ((GObject*) _tmp86_, "sensitive", (GObject*) _tmp87_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp88_ = mark_read_item;
	_tmp89_ = mark_read_item;
	_tmp90_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp89_);
	_tmp91_ = _tmp90_;
	_tmp92_ = granite_accel_label_new_from_action_name (_ ("Mark as Read"), _tmp91_);
	g_object_ref_sink (_tmp92_);
	_tmp93_ = _tmp92_;
	gtk_container_add ((GtkContainer*) _tmp88_, (GtkWidget*) _tmp93_);
	_g_object_unref0 (_tmp93_);
	_tmp94_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp94_);
	mark_star_item = _tmp94_;
	_tmp95_ = mark_star_item;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp95_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_STAR);
	_tmp96_ = mark_star_item;
	_tmp97_ = mark_star_item;
	g_object_bind_property_with_closures ((GObject*) _tmp96_, "sensitive", (GObject*) _tmp97_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp98_ = mark_star_item;
	_tmp99_ = mark_star_item;
	_tmp100_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp99_);
	_tmp101_ = _tmp100_;
	_tmp102_ = granite_accel_label_new_from_action_name (_ ("Star"), _tmp101_);
	g_object_ref_sink (_tmp102_);
	_tmp103_ = _tmp102_;
	gtk_container_add ((GtkContainer*) _tmp98_, (GtkWidget*) _tmp103_);
	_g_object_unref0 (_tmp103_);
	_tmp104_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp104_);
	mark_unstar_item = _tmp104_;
	_tmp105_ = mark_unstar_item;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp105_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MARK_UNSTAR);
	_tmp106_ = mark_unstar_item;
	_tmp107_ = mark_unstar_item;
	g_object_bind_property_with_closures ((GObject*) _tmp106_, "sensitive", (GObject*) _tmp107_, "visible", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp108_ = mark_unstar_item;
	_tmp109_ = mark_unstar_item;
	_tmp110_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp109_);
	_tmp111_ = _tmp110_;
	_tmp112_ = granite_accel_label_new_from_action_name (_ ("Unstar"), _tmp111_);
	g_object_ref_sink (_tmp112_);
	_tmp113_ = _tmp112_;
	gtk_container_add ((GtkContainer*) _tmp108_, (GtkWidget*) _tmp113_);
	_g_object_unref0 (_tmp113_);
	_tmp114_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp114_);
	mark_menu = _tmp114_;
	_tmp115_ = mark_menu;
	_tmp116_ = mark_unread_item;
	gtk_container_add ((GtkContainer*) _tmp115_, (GtkWidget*) _tmp116_);
	_tmp117_ = mark_menu;
	_tmp118_ = mark_read_item;
	gtk_container_add ((GtkContainer*) _tmp117_, (GtkWidget*) _tmp118_);
	_tmp119_ = mark_menu;
	_tmp120_ = mark_star_item;
	gtk_container_add ((GtkContainer*) _tmp119_, (GtkWidget*) _tmp120_);
	_tmp121_ = mark_menu;
	_tmp122_ = mark_unstar_item;
	gtk_container_add ((GtkContainer*) _tmp121_, (GtkWidget*) _tmp122_);
	_tmp123_ = mark_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp123_);
	_tmp124_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-mark", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp124_);
	_tmp125_ = mark_menu;
	_tmp126_ = _g_object_ref0 (_tmp125_);
	_tmp127_ = g_strdup (_ ("Mark Conversation"));
	_tmp128_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp128_, (GtkWidget*) _tmp124_);
	_g_object_unref0 (_tmp124_);
	gtk_menu_button_set_popup (_tmp128_, _tmp126_);
	_g_object_unref0 (_tmp126_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp128_, _tmp127_);
	_g_free0 (_tmp127_);
	g_object_ref_sink (_tmp128_);
	mark_button = _tmp128_;
	_tmp129_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-archive", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp129_);
	archive_button = _tmp129_;
	_tmp130_ = archive_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp130_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_ARCHIVE);
	_tmp131_ = archive_button;
	_tmp132_ = application_instance;
	_tmp133_ = archive_button;
	_tmp134_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp133_);
	_tmp135_ = _tmp134_;
	_tmp137_ = _tmp136_ = gtk_application_get_accels_for_action (_tmp132_, _tmp135_);
	_tmp138_ = _tmp137_;
	_tmp138__length1 = _vala_array_length (_tmp136_);
	_tmp139_ = granite_markup_accel_tooltip (_tmp138_, (gint) _vala_array_length (_tmp136_), _ ("Move conversations to archive"));
	_tmp140_ = _tmp139_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp131_, _tmp140_);
	_g_free0 (_tmp140_);
	_tmp138_ = (_vala_array_free (_tmp138_, _tmp138__length1, (GDestroyNotify) g_free), NULL);
	_tmp141_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp141_);
	trash_button = _tmp141_;
	_tmp142_ = trash_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp142_, MAIL_MAIN_WINDOW_ACTION_PREFIX MAIL_MAIN_WINDOW_ACTION_MOVE_TO_TRASH);
	_tmp143_ = trash_button;
	_tmp144_ = application_instance;
	_tmp145_ = trash_button;
	_tmp146_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp145_);
	_tmp147_ = _tmp146_;
	_tmp149_ = _tmp148_ = gtk_application_get_accels_for_action (_tmp144_, _tmp147_);
	_tmp150_ = _tmp149_;
	_tmp150__length1 = _vala_array_length (_tmp148_);
	_tmp151_ = granite_markup_accel_tooltip (_tmp150_, (gint) _vala_array_length (_tmp148_), _ ("Move conversations to Trash"));
	_tmp152_ = _tmp151_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp143_, _tmp152_);
	_g_free0 (_tmp152_);
	_tmp150_ = (_vala_array_free (_tmp150_, _tmp150__length1, (GDestroyNotify) g_free), NULL);
	_tmp153_ = compose_button;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp153_);
	_tmp154_ = self->priv->spacing_widget;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp154_);
	_tmp155_ = self->priv->_search_entry;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp155_);
	_tmp156_ = reply_button;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp156_);
	_tmp157_ = reply_all_button;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp157_);
	_tmp158_ = forward_button;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp158_);
	_tmp159_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp159_);
	_tmp160_ = _tmp159_;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp160_);
	_g_object_unref0 (_tmp160_);
	_tmp161_ = mark_button;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp161_);
	_tmp162_ = archive_button;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp162_);
	_tmp163_ = trash_button;
	hdy_header_bar_pack_start ((HdyHeaderBar*) self, (GtkWidget*) _tmp163_);
	_tmp164_ = app_menu;
	hdy_header_bar_pack_end ((HdyHeaderBar*) self, (GtkWidget*) _tmp164_);
	_tmp165_ = mark_button;
	g_object_bind_property_with_closures ((GObject*) self, "can-mark", (GObject*) _tmp165_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp166_ = self->priv->_search_entry;
	g_object_bind_property_with_closures ((GObject*) self, "can-search", (GObject*) _tmp166_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp167_ = g_settings_new ("io.elementary.mail");
	settings = _tmp167_;
	_tmp168_ = settings;
	_tmp169_ = load_images_menuitem;
	g_settings_bind (_tmp168_, "always-load-remote-images", (GObject*) _tmp169_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp170_ = account_settings_menuitem;
	g_signal_connect_object ((GtkButton*) _tmp170_, "clicked", (GCallback) __mail_header_bar___lambda14__gtk_button_clicked, self, 0);
	_g_object_unref0 (settings);
	_g_object_unref0 (trash_button);
	_g_object_unref0 (archive_button);
	_g_object_unref0 (mark_button);
	_g_object_unref0 (mark_menu);
	_g_object_unref0 (mark_unstar_item);
	_g_object_unref0 (mark_star_item);
	_g_object_unref0 (mark_read_item);
	_g_object_unref0 (mark_unread_item);
	_g_object_unref0 (forward_button);
	_g_object_unref0 (reply_all_button);
	_g_object_unref0 (reply_button);
	_g_object_unref0 (app_menu);
	_g_object_unref0 (app_menu_popover);
	_g_object_unref0 (app_menu_grid);
	_g_object_unref0 (app_menu_separator);
	_g_object_unref0 (account_settings_menuitem);
	_g_object_unref0 (load_images_menuitem);
	_g_object_unref0 (compose_button);
	_g_object_unref0 (application_instance);
	return obj;
}

static void
mail_header_bar_class_init (MailHeaderBarClass * klass,
                            gpointer klass_data)
{
	mail_header_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MailHeaderBar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_mail_header_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mail_header_bar_set_property;
	G_OBJECT_CLASS (klass)->constructor = mail_header_bar_constructor;
	G_OBJECT_CLASS (klass)->finalize = mail_header_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_HEADER_BAR_CAN_MARK_PROPERTY, mail_header_bar_properties[MAIL_HEADER_BAR_CAN_MARK_PROPERTY] = g_param_spec_boolean ("can-mark", "can-mark", "can-mark", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_HEADER_BAR_CAN_SEARCH_PROPERTY, mail_header_bar_properties[MAIL_HEADER_BAR_CAN_SEARCH_PROPERTY] = g_param_spec_boolean ("can-search", "can-search", "can-search", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIL_HEADER_BAR_SEARCH_ENTRY_PROPERTY, mail_header_bar_properties[MAIL_HEADER_BAR_SEARCH_ENTRY_PROPERTY] = g_param_spec_object ("search-entry", "search-entry", "search-entry", gtk_search_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
mail_header_bar_instance_init (MailHeaderBar * self,
                               gpointer klass)
{
	self->priv = mail_header_bar_get_instance_private (self);
}

static void
mail_header_bar_finalize (GObject * obj)
{
	MailHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_HEADER_BAR, MailHeaderBar);
	_g_object_unref0 (self->priv->_search_entry);
	_g_object_unref0 (self->priv->spacing_widget);
	G_OBJECT_CLASS (mail_header_bar_parent_class)->finalize (obj);
}

static GType
mail_header_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailHeaderBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_header_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailHeaderBar), 0, (GInstanceInitFunc) mail_header_bar_instance_init, NULL };
	GType mail_header_bar_type_id;
	mail_header_bar_type_id = g_type_register_static (hdy_header_bar_get_type (), "MailHeaderBar", &g_define_type_info, 0);
	MailHeaderBar_private_offset = g_type_add_instance_private (mail_header_bar_type_id, sizeof (MailHeaderBarPrivate));
	return mail_header_bar_type_id;
}

GType
mail_header_bar_get_type (void)
{
	static volatile gsize mail_header_bar_type_id__volatile = 0;
	if (g_once_init_enter (&mail_header_bar_type_id__volatile)) {
		GType mail_header_bar_type_id;
		mail_header_bar_type_id = mail_header_bar_get_type_once ();
		g_once_init_leave (&mail_header_bar_type_id__volatile, mail_header_bar_type_id);
	}
	return mail_header_bar_type_id__volatile;
}

static void
_vala_mail_header_bar_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MailHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_HEADER_BAR, MailHeaderBar);
	switch (property_id) {
		case MAIL_HEADER_BAR_CAN_MARK_PROPERTY:
		g_value_set_boolean (value, mail_header_bar_get_can_mark (self));
		break;
		case MAIL_HEADER_BAR_CAN_SEARCH_PROPERTY:
		g_value_set_boolean (value, mail_header_bar_get_can_search (self));
		break;
		case MAIL_HEADER_BAR_SEARCH_ENTRY_PROPERTY:
		g_value_set_object (value, mail_header_bar_get_search_entry (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_mail_header_bar_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MailHeaderBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAIL_TYPE_HEADER_BAR, MailHeaderBar);
	switch (property_id) {
		case MAIL_HEADER_BAR_CAN_MARK_PROPERTY:
		mail_header_bar_set_can_mark (self, g_value_get_boolean (value));
		break;
		case MAIL_HEADER_BAR_CAN_SEARCH_PROPERTY:
		mail_header_bar_set_can_search (self, g_value_get_boolean (value));
		break;
		case MAIL_HEADER_BAR_SEARCH_ENTRY_PROPERTY:
		mail_header_bar_set_search_entry (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

