/* MailPage.c generated by valac 0.48.19, the Vala compiler
 * generated from MailPage.vala, do not modify */

/*-
 * Copyright 2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <glib.h>
#include <webkit2/webkit-web-extension.h>
#include <stdlib.h>
#include <string.h>
#include <jsc/jsc.h>
#include <libsoup/soup.h>
#include <gdk/gdk.h>

#define MAIL_TYPE_PAGE (mail_page_get_type ())
#define MAIL_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAIL_TYPE_PAGE, MailPage))
#define MAIL_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAIL_TYPE_PAGE, MailPageClass))
#define MAIL_IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAIL_TYPE_PAGE))
#define MAIL_IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAIL_TYPE_PAGE))
#define MAIL_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAIL_TYPE_PAGE, MailPageClass))

typedef struct _MailPage MailPage;
typedef struct _MailPageClass MailPageClass;
typedef struct _MailPagePrivate MailPagePrivate;
enum  {
	MAIL_PAGE_0_PROPERTY,
	MAIL_PAGE_NUM_PROPERTIES
};
static GParamSpec* mail_page_properties[MAIL_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))

struct _MailPage {
	GObject parent_instance;
	MailPagePrivate * priv;
};

struct _MailPageClass {
	GObjectClass parent_class;
};

struct _MailPagePrivate {
	gboolean show_images;
	WebKitWebPage* page;
};

struct _Block1Data {
	int _ref_count_;
	MailPage* self;
	WebKitWebPage* page;
};

static gint MailPage_private_offset;
static gpointer mail_page_parent_class = NULL;

GType mail_page_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MailPage, g_object_unref)
MailPage* mail_page_new (WebKitWebPage* page);
MailPage* mail_page_construct (GType object_type,
                               WebKitWebPage* page);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean mail_page_on_send_request (MailPage* self,
                                    WebKitWebPage* page,
                                    WebKitURIRequest* request,
                                    WebKitURIResponse* response);
static gboolean _mail_page_on_send_request_webkit_web_page_send_request (WebKitWebPage* _sender,
                                                                  WebKitURIRequest* request,
                                                                  WebKitURIResponse* redirected_response,
                                                                  gpointer self);
static gboolean mail_page_on_page_user_message_received (MailPage* self,
                                                  WebKitWebPage* page,
                                                  WebKitUserMessage* message);
static gboolean _mail_page_on_page_user_message_received_webkit_web_page_user_message_received (WebKitWebPage* _sender,
                                                                                         WebKitUserMessage* message,
                                                                                         gpointer self);
static void __lambda4_ (Block1Data* _data1_);
static void ___lambda4__webkit_web_editor_selection_changed (WebKitWebEditor* _sender,
                                                      gpointer self);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      gint stack_length,
                                      const const gchar* needle);
static void _vala_SoupURI_free (SoupURI* self);
static void mail_page_finalize (GObject * obj);
static GType mail_page_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* MAIL_PAGE_ALLOWED_SCHEMES[4] = {"cid", "data", "about", "elementary-mail"};

static inline gpointer
mail_page_get_instance_private (MailPage* self)
{
	return G_STRUCT_MEMBER_P (self, MailPage_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		MailPage* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->page);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gboolean
_mail_page_on_send_request_webkit_web_page_send_request (WebKitWebPage* _sender,
                                                         WebKitURIRequest* request,
                                                         WebKitURIResponse* redirected_response,
                                                         gpointer self)
{
	gboolean result;
	result = mail_page_on_send_request ((MailPage*) self, _sender, request, redirected_response);
	return result;
}

static gboolean
_mail_page_on_page_user_message_received_webkit_web_page_user_message_received (WebKitWebPage* _sender,
                                                                                WebKitUserMessage* message,
                                                                                gpointer self)
{
	gboolean result;
	result = mail_page_on_page_user_message_received ((MailPage*) self, _sender, message);
	return result;
}

static void
__lambda4_ (Block1Data* _data1_)
{
	MailPage* self;
	WebKitUserMessage* _tmp0_;
	WebKitUserMessage* _tmp1_;
	self = _data1_->self;
	_tmp0_ = webkit_user_message_new ("selection-changed", NULL);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	webkit_web_page_send_message_to_view (_data1_->page, _tmp1_, NULL, NULL, NULL);
	_g_object_unref0 (_tmp1_);
}

static void
___lambda4__webkit_web_editor_selection_changed (WebKitWebEditor* _sender,
                                                 gpointer self)
{
	__lambda4_ (self);
}

MailPage*
mail_page_construct (GType object_type,
                     WebKitWebPage* page)
{
	MailPage * self = NULL;
	Block1Data* _data1_;
	WebKitWebPage* _tmp0_;
	WebKitWebEditor* _tmp1_;
	g_return_val_if_fail (page != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (page);
	_g_object_unref0 (_data1_->page);
	_data1_->page = _tmp0_;
	self = (MailPage*) g_object_new (object_type, NULL);
	_data1_->self = g_object_ref (self);
	self->priv->page = _data1_->page;
	g_signal_connect_object (_data1_->page, "send-request", (GCallback) _mail_page_on_send_request_webkit_web_page_send_request, self, 0);
	g_signal_connect_object (_data1_->page, "user-message-received", (GCallback) _mail_page_on_page_user_message_received_webkit_web_page_user_message_received, self, 0);
	_tmp1_ = webkit_web_page_get_editor (_data1_->page);
	g_signal_connect_data (_tmp1_, "selection-changed", (GCallback) ___lambda4__webkit_web_editor_selection_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return self;
}

MailPage*
mail_page_new (WebKitWebPage* page)
{
	return mail_page_construct (MAIL_TYPE_PAGE, page);
}

static gboolean
mail_page_on_page_user_message_received (MailPage* self,
                                         WebKitWebPage* page,
                                         WebKitUserMessage* message)
{
	JSCContext* js_context = NULL;
	WebKitFrame* _tmp0_;
	JSCContext* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
	static GQuark _tmp5_label0 = 0;
	static GQuark _tmp5_label1 = 0;
	static GQuark _tmp5_label2 = 0;
	static GQuark _tmp5_label3 = 0;
	static GQuark _tmp5_label4 = 0;
	static GQuark _tmp5_label5 = 0;
	static GQuark _tmp5_label6 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (page != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = webkit_web_page_get_main_frame (page);
	_tmp1_ = webkit_frame_get_js_context (_tmp0_);
	js_context = _tmp1_;
	_tmp2_ = webkit_user_message_get_name (message);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("set-body-html")))) {
		switch (0) {
			default:
			{
				const gchar* body_html = NULL;
				GVariant* _tmp7_;
				GVariant* _tmp8_;
				const gchar* _tmp9_;
				JSCValue* body = NULL;
				JSCContext* _tmp10_;
				JSCValue* _tmp11_;
				JSCValue* _tmp12_;
				JSCContext* _tmp13_;
				const gchar* _tmp14_;
				JSCValue* _tmp15_;
				JSCValue* _tmp16_;
				_tmp7_ = webkit_user_message_get_parameters (message);
				_tmp8_ = _tmp7_;
				_tmp9_ = g_variant_get_string (_tmp8_, NULL);
				body_html = _tmp9_;
				_tmp10_ = js_context;
				_tmp11_ = jsc_context_evaluate (_tmp10_, "document.querySelector('#message-body')", (gssize) -1);
				body = _tmp11_;
				_tmp12_ = body;
				_tmp13_ = js_context;
				_tmp14_ = body_html;
				_tmp15_ = jsc_value_new_string (_tmp13_, _tmp14_);
				_tmp16_ = _tmp15_;
				jsc_value_object_set_property (_tmp12_, "innerHTML", _tmp16_);
				_g_object_unref0 (_tmp16_);
				result = TRUE;
				_g_object_unref0 (body);
				_g_object_unref0 (js_context);
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("get-body-html")))) {
		switch (0) {
			default:
			{
				JSCValue* val = NULL;
				JSCContext* _tmp17_;
				JSCValue* _tmp18_;
				JSCValue* _tmp19_;
				gchar* _tmp20_;
				GVariant* _tmp21_;
				GVariant* _tmp22_;
				WebKitUserMessage* _tmp23_;
				WebKitUserMessage* _tmp24_;
				_tmp17_ = js_context;
				_tmp18_ = jsc_context_evaluate (_tmp17_, "document.querySelector('body').innerHTML;", (gssize) -1);
				val = _tmp18_;
				_tmp19_ = val;
				_tmp20_ = jsc_value_to_string (_tmp19_);
				_tmp21_ = g_variant_new_take_string (_tmp20_);
				g_variant_ref_sink (_tmp21_);
				_tmp22_ = _tmp21_;
				_tmp23_ = webkit_user_message_new ("get-body-html", _tmp22_);
				g_object_ref_sink (_tmp23_);
				_tmp24_ = _tmp23_;
				webkit_user_message_send_reply (message, _tmp24_);
				_g_object_unref0 (_tmp24_);
				_g_variant_unref0 (_tmp22_);
				result = TRUE;
				_g_object_unref0 (val);
				_g_object_unref0 (js_context);
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("get-page-height")))) {
		switch (0) {
			default:
			{
				JSCValue* val = NULL;
				JSCContext* _tmp25_;
				JSCValue* _tmp26_;
				JSCValue* _tmp27_;
				GVariant* _tmp28_;
				GVariant* _tmp29_;
				WebKitUserMessage* _tmp30_;
				WebKitUserMessage* _tmp31_;
				_tmp25_ = js_context;
				_tmp26_ = jsc_context_evaluate (_tmp25_, "\n" \
"                Math.max(\n" \
"                    document.body.scrollHeight, document.body.offsetHe" \
"ight,\n" \
"                    document.documentElement.clientHeight, document.do" \
"cumentElement.scrollHeight, document.documentElement.offsetHeight\n" \
"                );\n" \
"                ", (gssize) -1);
				val = _tmp26_;
				_tmp27_ = val;
				_tmp28_ = g_variant_new_int32 (jsc_value_to_int32 (_tmp27_));
				g_variant_ref_sink (_tmp28_);
				_tmp29_ = _tmp28_;
				_tmp30_ = webkit_user_message_new ("get-page-height", _tmp29_);
				g_object_ref_sink (_tmp30_);
				_tmp31_ = _tmp30_;
				webkit_user_message_send_reply (message, _tmp31_);
				_g_object_unref0 (_tmp31_);
				_g_variant_unref0 (_tmp29_);
				result = TRUE;
				_g_object_unref0 (val);
				_g_object_unref0 (js_context);
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label3) ? _tmp5_label3 : (_tmp5_label3 = g_quark_from_static_string ("set-image-loading-enabled")))) {
		switch (0) {
			default:
			{
				gboolean enabled = FALSE;
				GVariant* _tmp32_;
				GVariant* _tmp33_;
				_tmp32_ = webkit_user_message_get_parameters (message);
				_tmp33_ = _tmp32_;
				enabled = g_variant_get_boolean (_tmp33_);
				self->priv->show_images = enabled;
				if (enabled) {
					JSCContext* _tmp34_;
					JSCValue* _tmp35_;
					JSCValue* _tmp36_;
					_tmp34_ = js_context;
					_tmp35_ = jsc_context_evaluate (_tmp34_, "var images = document.images;\n" \
"                        for(var i = 0; i < images.length; i++) {\n" \
"                            images[i].src = images[i].src\n" \
"                        }", (gssize) -1);
					_tmp36_ = _tmp35_;
					_g_object_unref0 (_tmp36_);
				}
				result = TRUE;
				_g_object_unref0 (js_context);
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label4) ? _tmp5_label4 : (_tmp5_label4 = g_quark_from_static_string ("execute-editor-command")))) {
		switch (0) {
			default:
			{
				gchar* command = NULL;
				gchar* argument = NULL;
				GVariant* _tmp37_;
				GVariant* _tmp38_;
				gchar* _tmp39_ = NULL;
				gchar* _tmp40_ = NULL;
				JSCValue* document = NULL;
				JSCContext* _tmp41_;
				JSCValue* _tmp42_;
				JSCValue** parameters = NULL;
				JSCContext* _tmp43_;
				const gchar* _tmp44_;
				JSCValue* _tmp45_;
				JSCContext* _tmp46_;
				JSCValue* _tmp47_;
				JSCContext* _tmp48_;
				const gchar* _tmp49_;
				JSCValue* _tmp50_;
				JSCValue** _tmp51_;
				gint parameters_length1;
				gint _parameters_size_;
				JSCValue* ret = NULL;
				JSCValue* _tmp52_;
				JSCValue** _tmp53_;
				gint _tmp53__length1;
				JSCValue* _tmp54_;
				gboolean _tmp55_ = FALSE;
				JSCValue* _tmp56_;
				_tmp37_ = webkit_user_message_get_parameters (message);
				_tmp38_ = _tmp37_;
				g_variant_get (_tmp38_, "(ss)", &_tmp39_, &_tmp40_, NULL);
				_g_free0 (command);
				command = _tmp39_;
				_g_free0 (argument);
				argument = _tmp40_;
				_tmp41_ = js_context;
				_tmp42_ = jsc_context_evaluate (_tmp41_, "document", (gssize) -1);
				document = _tmp42_;
				_tmp43_ = js_context;
				_tmp44_ = command;
				_tmp45_ = jsc_value_new_string (_tmp43_, _tmp44_);
				_tmp46_ = js_context;
				_tmp47_ = jsc_value_new_boolean (_tmp46_, FALSE);
				_tmp48_ = js_context;
				_tmp49_ = argument;
				_tmp50_ = jsc_value_new_string (_tmp48_, _tmp49_);
				_tmp51_ = g_new0 (JSCValue*, 3 + 1);
				_tmp51_[0] = _tmp45_;
				_tmp51_[1] = _tmp47_;
				_tmp51_[2] = _tmp50_;
				parameters = _tmp51_;
				parameters_length1 = 3;
				_parameters_size_ = parameters_length1;
				_tmp52_ = document;
				_tmp53_ = parameters;
				_tmp53__length1 = parameters_length1;
				_tmp54_ = jsc_value_object_invoke_methodv (_tmp52_, "execCommand", (guint) _tmp53__length1, _tmp53_);
				ret = _tmp54_;
				_tmp56_ = ret;
				if (!jsc_value_is_boolean (_tmp56_)) {
					_tmp55_ = TRUE;
				} else {
					JSCValue* _tmp57_;
					_tmp57_ = ret;
					_tmp55_ = jsc_value_to_boolean (_tmp57_) == FALSE;
				}
				if (_tmp55_) {
					JSCValue* _tmp58_;
					gchar* _tmp59_;
					gchar* _tmp60_;
					_tmp58_ = ret;
					_tmp59_ = jsc_value_to_string (_tmp58_);
					_tmp60_ = _tmp59_;
					g_critical ("MailPage.vala:82: %s", _tmp60_);
					_g_free0 (_tmp60_);
				}
				result = TRUE;
				_g_object_unref0 (ret);
				parameters = (_vala_array_free (parameters, parameters_length1, (GDestroyNotify) g_object_unref), NULL);
				_g_object_unref0 (document);
				_g_free0 (argument);
				_g_free0 (command);
				_g_object_unref0 (js_context);
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label5) ? _tmp5_label5 : (_tmp5_label5 = g_quark_from_static_string ("query-command-state")))) {
		switch (0) {
			default:
			{
				const gchar* command = NULL;
				GVariant* _tmp61_;
				GVariant* _tmp62_;
				const gchar* _tmp63_;
				JSCValue* document = NULL;
				JSCContext* _tmp64_;
				JSCValue* _tmp65_;
				JSCValue** parameters = NULL;
				JSCContext* _tmp66_;
				const gchar* _tmp67_;
				JSCValue* _tmp68_;
				JSCValue** _tmp69_;
				gint parameters_length1;
				gint _parameters_size_;
				JSCValue* ret = NULL;
				JSCValue* _tmp70_;
				JSCValue** _tmp71_;
				gint _tmp71__length1;
				JSCValue* _tmp72_;
				JSCValue* _tmp73_;
				_tmp61_ = webkit_user_message_get_parameters (message);
				_tmp62_ = _tmp61_;
				_tmp63_ = g_variant_get_string (_tmp62_, NULL);
				command = _tmp63_;
				_tmp64_ = js_context;
				_tmp65_ = jsc_context_evaluate (_tmp64_, "document", (gssize) -1);
				document = _tmp65_;
				_tmp66_ = js_context;
				_tmp67_ = command;
				_tmp68_ = jsc_value_new_string (_tmp66_, _tmp67_);
				_tmp69_ = g_new0 (JSCValue*, 1 + 1);
				_tmp69_[0] = _tmp68_;
				parameters = _tmp69_;
				parameters_length1 = 1;
				_parameters_size_ = parameters_length1;
				_tmp70_ = document;
				_tmp71_ = parameters;
				_tmp71__length1 = parameters_length1;
				_tmp72_ = jsc_value_object_invoke_methodv (_tmp70_, "queryCommandState", (guint) _tmp71__length1, _tmp71_);
				ret = _tmp72_;
				_tmp73_ = ret;
				if (jsc_value_is_boolean (_tmp73_)) {
					JSCValue* _tmp74_;
					GVariant* _tmp75_;
					GVariant* _tmp76_;
					WebKitUserMessage* _tmp77_;
					WebKitUserMessage* _tmp78_;
					_tmp74_ = ret;
					_tmp75_ = g_variant_new_boolean (jsc_value_to_boolean (_tmp74_));
					g_variant_ref_sink (_tmp75_);
					_tmp76_ = _tmp75_;
					_tmp77_ = webkit_user_message_new ("query-command-state", _tmp76_);
					g_object_ref_sink (_tmp77_);
					_tmp78_ = _tmp77_;
					webkit_user_message_send_reply (message, _tmp78_);
					_g_object_unref0 (_tmp78_);
					_g_variant_unref0 (_tmp76_);
				} else {
					JSCValue* _tmp79_;
					gchar* _tmp80_;
					gchar* _tmp81_;
					_tmp79_ = ret;
					_tmp80_ = jsc_value_to_string (_tmp79_);
					_tmp81_ = _tmp80_;
					g_critical ("MailPage.vala:96: %s", _tmp81_);
					_g_free0 (_tmp81_);
				}
				result = TRUE;
				_g_object_unref0 (ret);
				parameters = (_vala_array_free (parameters, parameters_length1, (GDestroyNotify) g_object_unref), NULL);
				_g_object_unref0 (document);
				_g_object_unref0 (js_context);
				return result;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label6) ? _tmp5_label6 : (_tmp5_label6 = g_quark_from_static_string ("get-selected-text")))) {
		switch (0) {
			default:
			{
				JSCValue* val = NULL;
				JSCContext* _tmp82_;
				JSCValue* _tmp83_;
				JSCValue* _tmp84_;
				_tmp82_ = js_context;
				_tmp83_ = jsc_context_evaluate (_tmp82_, "document.defaultView.getSelection().getRangeAt(0).toString();", (gssize) -1);
				val = _tmp83_;
				_tmp84_ = val;
				if (jsc_value_is_string (_tmp84_)) {
					JSCValue* _tmp85_;
					gchar* _tmp86_;
					gchar* _tmp87_;
					GVariant* _tmp88_;
					GVariant* _tmp89_;
					WebKitUserMessage* _tmp90_;
					WebKitUserMessage* _tmp91_;
					_tmp85_ = val;
					_tmp86_ = jsc_value_to_string (_tmp85_);
					_tmp87_ = _tmp86_;
					_tmp88_ = g_variant_new_string (_tmp87_);
					g_variant_ref_sink (_tmp88_);
					_tmp89_ = _tmp88_;
					_tmp90_ = webkit_user_message_new ("get-selected-text", _tmp89_);
					g_object_ref_sink (_tmp90_);
					_tmp91_ = _tmp90_;
					webkit_user_message_send_reply (message, _tmp91_);
					_g_object_unref0 (_tmp91_);
					_g_variant_unref0 (_tmp89_);
					_g_free0 (_tmp87_);
				} else {
					JSCValue* _tmp92_;
					gchar* _tmp93_;
					gchar* _tmp94_;
					_tmp92_ = val;
					_tmp93_ = jsc_value_to_string (_tmp92_);
					_tmp94_ = _tmp93_;
					g_critical ("MailPage.vala:105: no selection range: %s", _tmp94_);
					_g_free0 (_tmp94_);
				}
				result = TRUE;
				_g_object_unref0 (val);
				_g_object_unref0 (js_context);
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				const gchar* _tmp95_;
				const gchar* _tmp96_;
				_tmp95_ = webkit_user_message_get_name (message);
				_tmp96_ = _tmp95_;
				g_critical ("MailPage.vala:110: Unhandled message name: %s", _tmp96_);
				break;
			}
		}
	}
	result = FALSE;
	_g_object_unref0 (js_context);
	return result;
}

static gboolean
_vala_string_array_contains (const gchar* * stack,
                             gint stack_length,
                             const const gchar* needle)
{
	gint i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_vala_SoupURI_free (SoupURI* self)
{
	g_boxed_free (soup_uri_get_type (), self);
}

static gboolean
mail_page_on_send_request (MailPage* self,
                           WebKitWebPage* page,
                           WebKitURIRequest* request,
                           WebKitURIResponse* response)
{
	gboolean should_load = FALSE;
	SoupURI* uri = NULL;
	const gchar* _tmp0_;
	SoupURI* _tmp1_;
	gboolean _tmp2_ = FALSE;
	SoupURI* _tmp3_;
	gboolean _tmp8_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (page != NULL, FALSE);
	g_return_val_if_fail (request != NULL, FALSE);
	should_load = FALSE;
	_tmp0_ = webkit_uri_request_get_uri (request);
	_tmp1_ = soup_uri_new (_tmp0_);
	uri = _tmp1_;
	_tmp3_ = uri;
	if (_tmp3_ != NULL) {
		SoupURI* _tmp4_;
		const gchar* _tmp5_;
		_tmp4_ = uri;
		_tmp5_ = soup_uri_get_scheme (_tmp4_);
		_tmp2_ = _vala_string_array_contains (MAIL_PAGE_ALLOWED_SCHEMES, G_N_ELEMENTS (MAIL_PAGE_ALLOWED_SCHEMES), _tmp5_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		should_load = TRUE;
	} else {
		if (self->priv->show_images) {
			should_load = TRUE;
		} else {
			WebKitUserMessage* _tmp6_;
			WebKitUserMessage* _tmp7_;
			_tmp6_ = webkit_user_message_new ("image-load-blocked", NULL);
			g_object_ref_sink (_tmp6_);
			_tmp7_ = _tmp6_;
			webkit_web_page_send_message_to_view (page, _tmp7_, NULL, NULL, NULL);
			_g_object_unref0 (_tmp7_);
		}
	}
	if (should_load) {
		_tmp8_ = GDK_EVENT_PROPAGATE;
	} else {
		_tmp8_ = GDK_EVENT_STOP;
	}
	result = _tmp8_;
	__vala_SoupURI_free0 (uri);
	return result;
}

static void
mail_page_class_init (MailPageClass * klass,
                      gpointer klass_data)
{
	mail_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MailPage_private_offset);
	G_OBJECT_CLASS (klass)->finalize = mail_page_finalize;
}

static void
mail_page_instance_init (MailPage * self,
                         gpointer klass)
{
	self->priv = mail_page_get_instance_private (self);
	self->priv->show_images = FALSE;
}

static void
mail_page_finalize (GObject * obj)
{
	MailPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAIL_TYPE_PAGE, MailPage);
	G_OBJECT_CLASS (mail_page_parent_class)->finalize (obj);
}

static GType
mail_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MailPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mail_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MailPage), 0, (GInstanceInitFunc) mail_page_instance_init, NULL };
	GType mail_page_type_id;
	mail_page_type_id = g_type_register_static (G_TYPE_OBJECT, "MailPage", &g_define_type_info, 0);
	MailPage_private_offset = g_type_add_instance_private (mail_page_type_id, sizeof (MailPagePrivate));
	return mail_page_type_id;
}

GType
mail_page_get_type (void)
{
	static volatile gsize mail_page_type_id__volatile = 0;
	if (g_once_init_enter (&mail_page_type_id__volatile)) {
		GType mail_page_type_id;
		mail_page_type_id = mail_page_get_type_once ();
		g_once_init_leave (&mail_page_type_id__volatile, mail_page_type_id);
	}
	return mail_page_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

